import { Injectable } from '@nestjs/common';
import { TimeConverterPort } from '../core/ports/time-converter.port';
import { DateTime, TimeZone } from 'timezonecomplete';

@Injectable()
export class TimeConverter implements TimeConverterPort {
  dateTimeToUtc = (
    date: string,
    time: string,
    timezone: string,
    dst?: boolean,
  ): Date => {
    try {
      if (!date || !time || !timezone) throw new Error();
      return new Date(
        new DateTime(`${date}T${time}`, TimeZone.zone(timezone, dst))
          .convert(TimeZone.zone('UTC'))
          .toIsoString(),
      );
    } catch (e) {
      return undefined;
    }
  };
}
